tbb::flow::interface7::continue_receiver Class Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
tbb::flow::interface7::continue_receiver Class Referenceabstract

Base class for receivers of completion messages. More...

`#include <flow_graph.h>`

Inheritance diagram for tbb::flow::interface7::continue_receiver:

## Public Types
typedef continue_msg | input_type
| The input type.
typedef sender< continue_msg > | predecessor_type
| The predecessor type for this node.
typedef internal::edge_container < predecessor_type > | built_predecessors_type
typedef built_predecessors_type::edge_list_type | predecessor_list_type
Public Types inherited from tbb::flow::interface7::receiver< continue_msg >
typedef continue_msg | input_type
| The input type of this receiver.
typedef sender< continue_msg > | predecessor_type
| The predecessor type for this node.
typedef internal::edge_container < predecessor_type > | built_predecessors_type
typedef built_predecessors_type::edge_list_type | predecessor_list_type

## Public Member Functions
| continue_receiver (int number_of_predecessors=0)
| Constructor.
| continue_receiver (const continue_receiver &src)
| Copy constructor.
virtual | ~continue_receiver ()
| Destructor.
bool | register_predecessor (predecessor_type &)
| Increments the trigger threshold.
bool | remove_predecessor (predecessor_type &)
| Decrements the trigger threshold. More...
built_predecessors_type & | built_predecessors ()
void | internal_add_built_predecessor (predecessor_type &s)
void | internal_delete_built_predecessor (predecessor_type &s)
void | copy_predecessors (predecessor_list_type &v)
size_t | predecessor_count ()
Public Member Functions inherited from tbb::flow::interface7::receiver< continue_msg >
virtual | ~receiver ()
| Destructor.
bool | try_put (const continue_msg &t)
| Put an item to the receiver.

## Protected Member Functions
task * | try_put_task (const input_type &)
void | reset_receiver (__TBB_PFG_RESET_ARG(reset_flags f))
virtual task * | execute ()=0
| Does whatever should happen when the threshold is reached. More...
bool | is_continue_receiver ()
Protected Member Functions inherited from tbb::flow::interface7::receiver< continue_msg >
virtual void | reset_receiver (__TBB_PFG_RESET_ARG(reset_flags f=rf_reset_protocol))=0

## Protected Attributes
built_predecessors_type | my_built_predecessors
spin_mutex | my_mutex
int | my_predecessor_count
int | my_current_count
int | my_initial_predecessor_count

## Friends
template<typename R , typename B >
class | run_and_put_task
template<typename X , typename Y >
class | internal::broadcast_cache
template<typename X , typename Y >
class | internal::round_robin_cache
template<typename U >
class | limiter_node
template<typename TT , typename M >
class | internal::successor_cache

## Detailed Description

Base class for receivers of completion messages.

These receivers automatically reset, but cannot be explicitly waited on

## Member Function Documentation

virtual task* tbb::flow::interface7::continue_receiver::execute | ( | ) |  |
| protectedpure virtual

Does whatever should happen when the threshold is reached.

This should be very fast or else spawn a task. This is called while the sender is blocked in the try_put().

bool tbb::flow::interface7::continue_receiver::remove_predecessor | ( | predecessor_type & | ) |  |
| inlinevirtual

Decrements the trigger threshold.

Does not check to see if the removal of the predecessor now makes the current count exceed the new threshold. So removing a predecessor while the graph is active can cause unexpected results.

Reimplemented from tbb::flow::interface7::receiver< continue_msg >.

The documentation for this class was generated from the following file:

- flow_graph.h

Copyright © 2005-2015 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.